<?php
// +----------------------------------------------------------------------
// | 前端基础控制器
// +----------------------------------------------------------------------
// | Copyright (c) 2018 https://blog.junphp.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: 小黄牛 <1731223728@qq.com>
// +----------------------------------------------------------------------

namespace app\common\controller;

use app\common\controller\Emptys;
use think\facade\Request;

class _Index extends Emptys
{
   
    // 后台中间件绑定
    protected $middleware = [
        // 因为中间件带分类，所以我们在绑定的时候也得加上命名空间
        // 公共验证
        // 'app\http\middleware\admin\Auth'
    ];

    // 代码管理架构
    protected function _autoload($_this) {
        $DS = DIRECTORY_SEPARATOR;
        // 获得控制器名称
        $controller = Request::instance()->controller();
        // 获得操作名称
        $action     = Request::instance()->action();
        // 操作方法文件的绝对地址 
        $url = APP_PATH.'index'.$DS.'controller'.$DS.$controller.$DS.$action.'.php';
        // 操作方法不存在文件不存在调用基础类404重定向
        if (!file_exists($url)) {
            return $this->__empty();
        }
        // 构造出命名空间
        $url  = "\app\index\controller\\$controller\\$action";
        // 否则加载该文件
        $obj = new $url();
        $numargs = Request::instance()->param();
        // 统一加载run方法
        echo $obj->run($numargs, $_this);
    }

    // 权限验证
    protected function initialize()
    {
        // 先执行父类构造函数
        parent::initialize();
        // 启动模板布局
        $this->view->engine->layout(true);
    }

    // 用于后台输出JSON
    protected function _json($code, $msg, $list=[]) {
       return json_encode([
                'code' => "$code",
                'msg' => $msg,
                'data' => $list
            ], JSON_UNESCAPED_UNICODE);
    }

    // 用于后台判断不能为空，并且可以为0的判断
    protected static function isset_empty($param, $key) {
        if (!isset($param[$key])) return false;
        if (trim($param[$key]) == '') return false;
        return true;
    }
}