<?php
// +----------------------------------------------------------------------
// | CMD命令 - create命令
// +----------------------------------------------------------------------
// | Copyright (c) 2018 https://blog.junphp.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: 小黄牛 <1731223728@qq.com>
// +----------------------------------------------------------------------

namespace cmd;
use cmd\Common;

class Create extends Common{
    /**
     * 命令行参数
    */
    private static $_param = [];
    
    /**
     * 用于php命令行分流
     * @todo 无
     * @author 小黄牛
     * @version v1.0.0.8 + 2018.11.22
     * @deprecated 暂不弃用
     * @global 无
     * @param array $param 命令行
     * @return json
    */
    public static function run($param){
		static::$_param = $param;
		self::_Create();
	}
	
	/**
	 * 切换命令行所处目录结构
	 * @todo 无
	 * @author 小黄牛
	 * @version v1.0.0.8 + 2018.11.22
	 * @deprecated 暂不弃用
	 * @global 无
	 * @return void
	*/
	private static function _Create() {
		# create命令可以存在以下几种可能
		# create -m 需要创建的分组名称
		# create -a 分组名称 需要创建的控制器名称，（注意：指定的分组不存在，不会自动创建）
		# create -a 分组名称 控制器名称 需要创建的操作方法名称 备注【选填】，（注意：指定的分组不存在，不会自动创建，但指定的控制器不存在，则会自动创建）

		if (empty(self::$_param[1])) {
			self::json('02','请输入create对应的操作指令');
		}
		switch (self::$_param[1]) {
			case '-m': self::_m();break;
			case '-a': self::_a();break;
		}
	}

	/**
	 * M：创建分组
	 * @todo 无
	 * @author 小黄牛
	 * @version v1.0.3 + 2020.1.3
	 * @deprecated 暂不弃用
	 * @global 无
	 * @return void
	*/
	private static function _m() {
		if (empty(self::$_param[2])) {
			self::json('02','请输入需要创建的分组名称');
		}
		$path = ROOT_PATH.'/app/'.self::$_param[2].'/';
		if (file_exists($path)) {
			self::json('02', $path .' 该分组已存在！');
		}

		// 中间控制器
		$model = ucfirst(self::$_param[2]);
		$Common = ROOT_PATH.'/app/common/controller/_'.$model.'.php';
$txt = '<?php
// +----------------------------------------------------------------------
// | '.$model.'分组基础控制器
// +----------------------------------------------------------------------
// | Copyright (c) 2018 https://blog.junphp.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: 小黄牛 <1731223728@qq.com>
// +----------------------------------------------------------------------

namespace app\common\controller;

use app\common\controller\Emptys;
use think\facade\Request;

class _'.$model.' extends Emptys
{
	
	// 后台中间件绑定
	protected $middleware = [
		// 因为中间件带分类，所以我们在绑定的时候也得加上命名空间
		// 公共验证
		// "app\http\middleware\admin\Auth"
	];

	// 代码管理架构
	protected function _autoload($_this) {
		$DS = DIRECTORY_SEPARATOR;
		// 获得控制器名称
		$controller = Request::instance()->controller();
		// 获得操作名称
		$action     = Request::instance()->action();
		// 操作方法文件的绝对地址 
		$url = APP_PATH."'.self::$_param[2].'".$DS."controller".$DS.$controller.$DS.$action.".php";
		// 操作方法不存在文件不存在调用基础类404重定向
		if (!file_exists($url)) {
			return $this->__empty();
		}
		// 构造出命名空间
		$url  = "\app\\'.self::$_param[2].'\controller\\$controller\\$action";
		// 否则加载该文件
		$obj = new $url();
		$numargs = Request::instance()->param();
		// 统一加载run方法
		echo $obj->run($numargs, $_this);
	}

	// 权限验证
	protected function initialize()
	{
		// 先执行父类构造函数
		parent::initialize();
		// 启动模板布局
		$this->view->engine->layout(true);
	}

	// 用于后台输出JSON
	protected function _json($code, $msg, $list=[]) {
		return json_encode([
				"code" => "$code",
				"msg" => $msg,
				"data" => $list
			], JSON_UNESCAPED_UNICODE);
	}

	// 用于后台判断不能为空，并且可以为0的判断
	protected static function isset_empty($param, $key) {
		if (!isset($param[$key])) return false;
		if (trim($param[$key]) == "" ) return false;
		return true;
	}
}';
		$res = @file_put_contents($Common, $txt);
        if (!$res) {
			self::json('02', '分组文件创建失败，请检查是否有写权限！');
		}
		//创建分组目录
		$path = ROOT_PATH.'/app/'.self::$_param[2].'/';
		$res = @mkdir($path, 0755);
		if (!$res) {
			self::json('02', '分组目录失败，请检查是否有写权限！');
		}
		//创建控制器目录
		$path = ROOT_PATH.'/app/'.self::$_param[2].'/controller/';
		$res = @mkdir($path, 0755);
		if (!$res) {
			self::json('02', '分组控制器目录失败，请检查是否有写权限！');
		}
		self::json('02', '分组创建完成！');
	}

	/**
	 * A：创建控制器
	 * @todo 无
	 * @author 小黄牛
	 * @version v1.0.3 + 2020.1.3
	 * @deprecated 暂不弃用
	 * @global 无
	 * @return void
	*/
	private static function _a() {
		if (empty(self::$_param[2])) {
			self::json('02','请输入分组名称');
		}
		if (empty(self::$_param[3])) {
			self::json('02','请输入需要创建的控制器名称');
		}
		
		$path = ROOT_PATH.'/app/'.self::$_param[2].'/';
		if (!file_exists($path)) {
			self::json('02', $path .' 指定分组不存在！');
		}
		// 控制器是否存在
		$model = ucfirst(self::$_param[3]);
		$controller = ROOT_PATH.'/app/'.self::$_param[2].'/controller/'.$model.'.php';
		// 不存在，创建控制器
		if (!file_exists($controller)) {
$txt = '<?php
// +----------------------------------------------------------------------
// | '.$model.'基础控制器
// +----------------------------------------------------------------------
// | Copyright (c) 2018 https://blog.junphp.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: 小黄牛 <1731223728@qq.com>
// +----------------------------------------------------------------------

namespace app\\'.self::$_param[2].'\controller;

use app\common\controller\_'.ucfirst(self::$_param[2]).';

class '.$model.' extends _'.ucfirst(self::$_param[2]).'
{
    // 统一方法分流加载
    protected function initialize()
    {
        // 先执行父类构造函数
        parent::initialize();
        // 方法加载
        $this->_autoload($this);
    }
}';
			$res = @file_put_contents($controller, $txt);
			if (!$res) {
				self::json('02', '控制器文件创建失败，请检查是否有写权限！');
			}
			// 创建操作方法目录
			$path = ROOT_PATH.'/app/'.self::$_param[2].'/controller/'.$model.'/';
			$res = @mkdir($path, 0755);
			if (!$res) {
				self::json('02', '操作方法目录失败，请检查是否有写权限！');
			}
		}

		// 需要创建操作方法
		if (!empty(self::$_param[4])) {
			$action = ROOT_PATH.'/app/'.self::$_param[2].'/controller/'.$model.'/'.self::$_param[4].'.php';
			if (file_exists($action)) {
				self::json('02', $model.'/'.self::$_param[4].' 该操作方法已存在！');
			}
			// 否则创建
			$des = '';
			if (!empty(self::$_param[5])) {
				$des = self::$_param[5];
			}
$txt = '<?php
// +----------------------------------------------------------------------
// | '.$des.'
// +----------------------------------------------------------------------
// | Copyright (c) 2018 https://blog.junphp.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: 小黄牛 <1731223728@qq.com>
// +----------------------------------------------------------------------

namespace app\\'.self::$_param[2].'\controller\\'.$model.';
use app\common\controller\_'.ucfirst(self::$_param[2]).';

class '.self::$_param[4].' extends _'.ucfirst(self::$_param[2]).'
{

    // 默认留空即可
    protected function initialize()
    {
        parent::initialize();
    }

    // 统一返回方法
    // $param 必留，用于接收get、post的参数传递
    // $_this 父类的obj实例
    public function run($param=[], $_this) {
        return $this->fetch();
    }
    
}';
			$res = @file_put_contents($action, $txt);
			if (!$res) {
				self::json('02', '操作方法文件创建失败，请检查是否有写权限！');
			}
		}
		self::json('02', '创建完成！');
	}

	
}